stages:
    - build
    - release

build64:
    stage: build
    script:
        - source /tools/setup.sh
        - cd base-sim/
        - ./manager.sh update_deps
        - make restore 
        - make patch
        - make CONFIG=templates/rv64imac.inc 
        - make regress opts='--filter=rv64 --parallel=90 --sub' CONFIG_ISA=RV64IMAC
        - make regress opts='--filter=rv64 --final' CONFIG_ISA=RV64IMAC 
        - make aapg opts='--config=rv64imac* --test_count=10 --parallel=30 --debug' CONFIG_ISA=RV64IMAC
        - make regress opts='--list=aapg.list --sub --test_opts='--timeout=10m' --parallel=30' CONFIG_ISA=RV64IMAC
        - make regress opts='--list=aapg.list --final' CONFIG_ISA=RV64IMAC
#        - make torture opts='--config=all'
#        - make regress opts='--list=riscv-torture.list --sub --test_opts='--timeout=100m' --parallel=10' CONFIG_ISA=RV64IMAC
#        - make regress opts='--list=riscv-torture.list --final' CONFIG_ISA=RV64IMAC
#        - make csmith opts='--test_count=30 --parallel=10 --debug' CONFIG_ISA=RV64IMAC
#        - make regress opts='--list=csmith.list --parallel=150 --sub'  CONFIG_ISA=RV64IMAC
#        - make regress opts='--list=csmith.list --final'  CONFIG_ISA=RV64IMAC
    only:
        refs:
            - master
    tags:
        - core-runner

build32:
    stage: build
    script:
        - source /tools/setup.sh
        - cd base-sim/
        - ./manager.sh update_deps
        - make restore 
        - make patch
        - make CONFIG=templates/rv32imac.inc 
        - make regress opts='--filter=rv32 --parallel=90 --sub' CONFIG_ISA=RV32IMAC
        - make regress opts='--filter=rv32 --final' CONFIG_ISA=RV32IMAC
        - make aapg opts='--config=rv32imac_bringup --test_count=10 --parallel=30   --aapg_opts='--arch=rv32'' CONFIG_ISA=RV32IMAC
        - make regress opts='--list=aapg.list --sub --test_opts='--timeout=10m' --parallel=30' CONFIG_ISA=RV32IMAC
        - make regress opts='--list=aapg.list --final' CONFIG_ISA=RV32IMAC
#        - make torture opts='--config=all'
#        - make regress opts='--list=riscv-torture.list --sub --test_opts='--timeout=100m' --parallel=10' CONFIG_ISA=RV32IMAC
#        - make regress opts='--list=riscv-torture.list --final' CONFIG_ISA=RV32IMAC
    only:
        refs:
            - master
    tags:
        - core-runner

for_merge:
    stage: build
    script:
        - source /tools/setup.sh
        - cd base-sim/
        - ./manager.sh update_deps
        - make restore 
        - make patch
        - make CONFIG=templates/rv64imac.inc VERILATESIM=slow
        - make regress opts='--filter=rv64 --parallel=90 --sub' CONFIG_ISA=RV64IMAC
        - make regress opts='--filter=rv64 --final' CONFIG_ISA=RV64IMAC
        - make aapg opts='--config=rv64imac_bringup --test_count=1 --parallel=30 --debug' CONFIG_ISA=RV64IMAC
        - make regress opts='--list=aapg.list --sub --test_opts='--timeout=10m' --parallel=30' CONFIG_ISA=RV64IMAC
        - make regress opts='--list=aapg.list --final' CONFIG_ISA=RV64IMAC
        - make restore clean_verif
        - make CONFIG=templates/rv32imac.inc VERILATESIM=slow
        - make regress opts='--filter=rv32 --parallel=90 --sub' CONFIG_ISA=RV32IMAC
        - make regress opts='--filter=rv32 --final' CONFIG_ISA=RV32IMAC
        - make aapg opts='--config=rv32imac_bringup --test_count=1   --aapg_opts='--arch=rv32'' CONFIG_ISA=RV32IMAC
        - make regress opts='--list=aapg.list --sub --test_opts='--timeout=10m' --parallel=30' CONFIG_ISA=RV32IMAC
        - make regress opts='--list=aapg.list --final' CONFIG_ISA=RV32IMAC
#        - make torture opts='--config=rv32imac_bringup'
#        - make regress opts='--list=riscv-torture.list --sub --parallel=10' CONFIG_ISA=RV32IMAC
#        - make regress opts='--list=riscv-torture.list --final' CONFIG_ISA=RV32IMAC
    only:
        refs:
            - merge_requests
    tags:
        - core-runner
    when: manual

release:
    stage: release
    script:
        - python3 /scratch/version-extract.py
        - source /tools/setup.sh
        - cd base-sim/
        - ./manager.sh update_deps
        - make CONFIG=templates/synth32.inc release-verilog-artifacts
        - cd ..
        - cp version.txt verilog-artifacts
    only:
        refs:
            - master
    tags:
        - core-runner
    artifacts:
      name: verilog-artifacts
      paths:
        - ./verilog-artifacts
    except:
      - schedules
#build32:
#    variables:
#        GIT_SUBMODULE_STRATEGY: recursive
#    script:
#        - source /tools/setup.sh
#        - make restore 
#        - make patch
#        - make generate_verilog SYNTH=SIM MUL=fpga ISA=RV32IMAC MULSTAGES=4 DIVSTAGES=32
#        - make link_verilator generate_boot_files MUL=fpga ISA=RV32IMAC MULSTAGES=4 DIVSTAGES=32
#        - make regress opts='--filter=rv32 --sub --parallel=90' CONFIG_ISA=RV32IMAC
#        - make regress opts='--filter=rv32 --final'
#        - make test opts="--test=hello_world --suite=zephyr --nospike" CONFIG_ISA=RV32IMAC
#        - make test opts="--test=philosophers --suite=zephyr --nospike" CONFIG_ISA=RV32IMAC
#        - make test opts="--test=synchronization --suite=zephyr --nospike" CONFIG_ISA=RV32IMAC
#    only:
#        - master
#    tags:
#        - core-runner
#
# gen_artifacts:
#     variables:
#         GIT_SUBMODULE_STRATEGY: recursive
#     script:
#         - source /tools/setup.sh
#         - make restore 
#         - make generate_verilog SYNTH=SIM MUL=fpga ISA=RV64IMAC MULSTAGES=8 DIVSTAGES=64 RTLDUMP=False
#         - tar -cvzf verilog_eclassrv64imac.tar.gz verilog/
#         - make restore 
#         - make generate_verilog SYNTH=SIM MUL=fpga ISA=RV32IMAC MULSTAGES=4 DIVSTAGES=32 RTLDUMP=False
#         - tar -cvzf verilog_eclassrv32imac.tar.gz verilog/
#     artifacts:
#         paths:
#             - verilog_eclassrv64imac.tar.gz
#             - verilog_eclassrv32imac.tar.gz
#     only:
#         - master
#     tags:
#         - e-class-build-regression
